﻿using C1.Win.C1FlexGrid;
using System;
using System.Drawing;
using System.Windows.Forms;

namespace FlexGrid_AdjustControlSize
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            numericUpDown1.Value = c1FlexGrid1.Cols.Count;
            numericUpDown2.Value = c1FlexGrid1.Rows.Count;

            c1FlexGrid1.Paint += C1FlexGrid1_Paint;

            //c1FlexGrid1.MaximumSize = new Size(400, 400);
        }

        private void C1FlexGrid1_Paint(object sender, PaintEventArgs e)
        {
            UpdateFlexGridSize();
        }

        void UpdateFlexGridSize()
        {
            c1FlexGrid1.BeginUpdate();
            if (c1FlexGrid1.Dock != DockStyle.Fill)
            {
                int width = c1FlexGrid1.Width;
                if (c1FlexGrid1.Dock != DockStyle.Top && c1FlexGrid1.Dock != DockStyle.Bottom)
                {
                    width = 0;
                    foreach (Column col in c1FlexGrid1.Cols)
                    {
                        width += col.WidthDisplay;
                        if (c1FlexGrid1.MaximumSize.Width != 0 && width >= c1FlexGrid1.MaximumSize.Width) break;
                        if (width > c1FlexGrid1.Parent.Width)
                        {
                            width -= col.WidthDisplay;
                            break;
                        }
                    }
                }
                int height = c1FlexGrid1.Height;
                if (c1FlexGrid1.Dock != DockStyle.Left && c1FlexGrid1.Dock != DockStyle.Right)
                {
                    height = 0;
                    foreach (Row row in c1FlexGrid1.Rows)
                    {
                        height += row.HeightDisplay;
                        if (c1FlexGrid1.MaximumSize.Height != 0 && height >= c1FlexGrid1.MaximumSize.Height) break;
                        if (height > (c1FlexGrid1.Parent.DisplayRectangle.Height))
                        {
                            height -= row.HeightDisplay;
                            break;
                        }
                    }
                }


                c1FlexGrid1.Size = new Size(width, height);
            }
            c1FlexGrid1.EndUpdate();
        }

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            c1FlexGrid1.Cols.Count = (int)numericUpDown1.Value;
        }

        private void numericUpDown2_ValueChanged(object sender, EventArgs e)
        {
            c1FlexGrid1.Rows.Count = (int)numericUpDown2.Value;
        }
    }
}
